# baseitem.py
import os
import grok
import waeup.viewlets as vw
from waeup.interfaces import IBaseItem
from zope.component import getMultiAdapter

class BaseItem(grok.Model):
    """
    Base item
    """
    #grok.implements(IBaseItem)
    
    def __init__(self, **kwargs):
        super(BaseItem, self).__init__()
        self.__dict__.update(kwargs)

class Index(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    #grok.context(IBaseItem)
    #grok.order(1)
    #grok.View(Index) # warum gibt das hier einen Fehler?
    grok.template('content')

class AddForm(grok.AddForm):
    template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))

    def __init__(self, context, request):
        super(AddForm, self).__init__(context, request)
        self.form_fields = grok.AutoFields(self.context-__class__) #.childClass)

    @grok.action('Add item')
    def add(self, **data):
        obj = self.context.__class__(**data) #.childClass(**data)
        id = data['id'].lower()
        self.context[id] = obj
        self.redirect(self.url('@@index'))

class EditForm(grok.EditForm):
    template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))
   
    def __init__(self, context, request):
        super(EditForm, self).__init__(context, request)
        self.form_fields = grok.AutoFields(self.context.__class__)
       
    def handle_edit_action(self, **data):
        grok.EditForm.handle_edit_action(self, **data)
        self.redirect(self.url('@@index'))

class AddViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    grok.context(IBaseItem)
    grok.view(vw.Add)
    #grok.name('add')
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='addform')
        self.form.update_form()

    def render(self):
        return self.form.render()


class EditViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    grok.context(IBaseItem)
    grok.view(vw.Edit)
    #grok.name('edit')
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='editform')
        self.form.update_form()

    def render(self):
        return self.form.render()
