import grok, grok.index
from hurry.query.query import Query, Text
from hurry.query import Eq
from waeup.app import University
from waeup.students.interfaces import IStudent, IStudentContainer
from waeup.students.student import Student
from waeup.viewlets import MainArea, LeftSidebar

class StudentIndexes(grok.Indexes):
     grok.site(University)
     grok.name('students_catalog')
     grok.context(IStudentContainer)

     name = grok.index.Field(attribute='name')


class StudentSearch(grok.Viewlet):
    grok.context(IStudentContainer)
    grok.viewletmanager(LeftSidebar)
    #grok.view(Student)
    grok.order(3)

    def update(self, query=None):
        self.search_result = []
        if query is not None:
            self.search_result = self.search_context(query)
            print "RESULT: ", list(self.search_result)

    def search_context(self, query):
        result = Query().searchResults(
            Eq(('students_catalog', 'name'), query)
            )
        return result
    
