import grok
import re
from zope import schema
from waeup.interfaces import IBaseContainer

class IFaculty(grok.interfaces.IContainer):
    """Representation of a university faculty.
    """
    id = schema.ASCIILine(
        title = u'ID of Faculty',
        default = 'XXX',
        required = True,
        constraint = (re.compile('^[A-Z]{3}$').match)
        )
    title = schema.TextLine(
        title = u'Title of Faculty',
        default = u'Faculty of',
        required = True
        )
    name = schema.TextLine(
        title = u'Name of Faculty',
        default = u'Unnamed',
        required = True,
        )


class IDepartment(IBaseContainer):
    """Representation of a university department.
    """
    id = schema.ASCIILine(
        title = u'ID of Department',
        default = 'XXX',
        required = True,
        constraint = (re.compile('^[A-Z]{3}$').match)
        )
    title = schema.TextLine(
        title = u'Title of Department',
        default = u'Department of',
        required = True
        )
    name = schema.TextLine(
        title = u'Name of Department',
        default = u'Unnamed',
        required = True,
        )


class ICourse(IBaseContainer):
    """Representation of a study course, provided by a department.
    """
    id = schema.ASCIILine(
        title = u'ID of Course',
        default = 'XXX',
        required = True,
        constraint = (re.compile('^[A-Z]{3,8}$').match)
        )
    name = schema.TextLine(
        title = u'Name of Course',
        default = u'Unnamed',
        required = True,
        )
